#include "mpi.h"
#include "mpiimpl.h"

size_t MPI_datatype_size[] = {
     (size_t)-1, sizeof(char), sizeof(short), sizeof(int), sizeof(long), 
     sizeof(unsigned char), sizeof(unsigned short), 
     sizeof(unsigned), sizeof(unsigned long), 
     sizeof(float), sizeof(double), sizeof(long double),
     sizeof(char /*byte*/), sizeof(long long int)
     };

/* index into pg_array is same as process rank in MPI_Comm_world */
struct MPI_pg_struct MPI_pg_array[MPI_MAX_NODES];

struct MPI_node_struct MPI_nodes[MPI_MAX_NODES];

int MPI_node_num;
int MPI_slaves = 0;
int MPI_num_nodes = 0;
int MPI_my_port = 0;
int MPI_my_list_sd = -1;
fd_set MPI_fdset;
int MPI_max_sd = -1;

char MPI_processor_name[MPI_MAX_PROCESSOR_NAME];
int MPI_processor_name_len;

MPI_Comm MPI_COMM_SELF = MPI_COMM_NULL;
MPI_Comm MPI_COMM_WORLD = MPI_COMM_NULL;
MPI_Comm MPI_COMM_PARENT = MPI_COMM_NULL;

/*========================================================================================*/

/* initialize state for this process */
void MPI_init_state() {
  int i;

#ifdef DEBUG
  printf("Init state\n");
#endif

  for(i = 0; i < MPI_MAX_NODES; i++) {
    MPI_pg_array[i].processor = NULL;
    MPI_nodes[i].sd = MPI_NOSOCKET;
    MPI_nodes[i].pid = MPI_PID_UNAVAILABLE;
  }
  FD_ZERO(&MPI_fdset);
  MPI_init_groups();
  MPI_initPorts();
  
  CALL_CHK(gethostname, (MPI_processor_name, MPI_MAX_PROCESSOR_NAME));
  MPI_processor_name_len = strlen(MPI_processor_name);
}
