#include "mpi.h"

#include <stdio.h>

#define WORKTAG		1
#define DIETAG		2

void master(), slave();

int myrank; /* SunOS has problems with this local decl. */

main(int argc,char *argv[]) {
  printf("HELLO1-MPI\n");
  
  if (MPI_Init(&argc, &argv) != MPI_SUCCESS){		/* initialize MPI */
    printf("MPI_Init error\n");
    exit(1);
  }
  
  MPI_Comm_rank(MPI_COMM_WORLD,	&myrank);
  printf("MPI_Init done on %d\n", myrank);
  if (myrank == 0) {
    master();
  } else {
    slave() ;
  }
  MPI_Finalize();			/* cleanup MPI */
  printf("MPI_Exit done on %d\n", myrank);
  exit(0);
}

void master() {
  MPI_Status	status;
  MPI_Info info;
  MPI_Comm intercomm;
  int proc = 2;
  int errors[proc];
  char *argv[] = { "" };
  int s,d;
  int size;

  MPI_Comm_size(MPI_COMM_WORLD, &size);

  printf("Start master  on %d\n", myrank);

  s = 5;
  MPI_Send(&s, 1, MPI_INT, 0, 0, MPI_COMM_WORLD);


if (size>1) {

  MPI_Recv(&d, 1, MPI_INT, 1, 5, MPI_COMM_WORLD, &status);
  printf("Received from slave %d\n", d);

  MPI_Recv(&d, 1, MPI_INT, 1, 15, MPI_COMM_WORLD, &status);
  printf("Received from slave %d\n", d);

  d = 999;
  MPI_Send(&d, 1, MPI_INT, 1, 26, MPI_COMM_WORLD);

  d = 111;
  MPI_Send(&d, 1, MPI_INT, 1, 25, MPI_COMM_WORLD);

  MPI_Recv(&d, 1, MPI_INT, 1, 16, MPI_COMM_WORLD, &status);
  printf("Received from slave %d\n", d);

  MPI_Recv(&d, 1, MPI_INT, 1, 17, MPI_COMM_WORLD, &status);
  printf("Received from slave %d\n", d);
}

  MPI_Recv(&d, 1, MPI_INT, 0, 0, MPI_COMM_WORLD, &status);
  printf("Received from myself %d\n", d);

}

void slave() {
  MPI_Status	status;
  MPI_Info info;
  MPI_Comm intercomm;
  int proc = 2;
  int errors[proc];
  char *argv[] = { "" };
  int d, s;

  printf("Start slave  on %d\n", myrank);

  if (myrank ==1) {

    s = 7;
    MPI_Send(&s, 1, MPI_INT, 0, 15, MPI_COMM_WORLD);

    s = 17;
    MPI_Send(&s, 1, MPI_INT, 0, 5, MPI_COMM_WORLD);

    MPI_Recv(&d, 1, MPI_INT, 0, 25, MPI_COMM_WORLD, &status);
    printf("Received from root %d\n", d);

    MPI_Recv(&d, 1, MPI_INT, 0, 26, MPI_COMM_WORLD, &status);
    printf("Received from root %d\n", d);

    s = 8;
    MPI_Send(&s, 1, MPI_INT, 0, 16, MPI_COMM_WORLD);  

    s = 9;
    MPI_Send(&s, 1, MPI_INT, 0, 17, MPI_COMM_WORLD); 

  }
}
