#include "mpi.h"
#include "mpiimpl.h"
 
#include <stdio.h>

void spawned(), not_spawned();

int myrank, rank, data; 
MPI_Comm intercomm, parent, merged_intracomm;

main(int argc,char *argv[]) {
  printf("HELLO10-MPI\n");
  
  if (MPI_Init(&argc, &argv) != MPI_SUCCESS){       /* initialize MPI */
    printf("MPI_Init error\n");
    exit(1);
  }
  
  MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
  printf("MPI_Init done on %d\n", myrank);
 
  MPI_Comm_get_parent(&parent);

  if (parent == MPI_COMM_NULL) {
	printf("I am not spawned\n");
	not_spawned();
  }
  else {
        printf("I am spawned\n");
	spawned();
  }

  MPI_Comm_rank(merged_intracomm, &rank);
  printf("New rank %d, intracom %d; old rank %d, parent %d\n", 
	rank, merged_intracomm, myrank, parent);
/*
  data = (rank == 0) ? 135 : 246;
  printf("Before b-cast %d at %d\n", data, rank);
  MPI_Bcast(&data, 1, MPI_INT, 0, merged_intracomm);
  printf("Rcv. from b-cast %d at %d\n", data, rank);
*/
  MPI_Finalize();           /* cleanup MPI */
  printf("MPI_Exit done on %d comm %d\n", myrank, MPI_COMM_WORLD);

  exit(0);
}

void not_spawned() {
  int proc = 2;
  char *spawn_argv[1] = { NULL };
  int errors[proc];
  int size1, size2;
  
  MPI_Comm_spawn("/home/predrag/com3200/tests/hello10", spawn_argv, proc,
         MPI_INFO_NULL, 0, MPI_COMM_WORLD, &intercomm, errors);

  MPI_Comm_size(intercomm, &size1);
  MPI_Comm_remote_size(intercomm, &size2);

  printf("Spawn intercomm has %d spawned and %d original nodes\n",
	size2, size1);

  printf("merging comm: %d\n", intercomm);
  MPI_Intercomm_merge(intercomm, 1, &merged_intracomm);
  printf("merged comm: %d\n", merged_intracomm);

}

void spawned() {
  int size1, size2;
  MPI_Comm dup;

  MPI_Comm_size(parent, &size1);
  MPI_Comm_remote_size(parent, &size2);

  printf("Parent intercomm has %d spawned and %d original nodes\n",
	size1, size2);
/*
  MPI_Comm_dup(MPI_COMM_WORLD, &dup);
  printf("duplicated World: %d\n", dup);
*/

  printf("merging comm: %d\n", parent);
  MPI_Intercomm_merge(parent, 0, &merged_intracomm);
  printf("merged comm: %d\n", merged_intracomm);

}
