#include "mpi.h"
#include "mpiimpl.h"
 
#include <stdio.h>

void spawned(), not_spawned();

int myrank, rank, data; 
MPI_Comm intercomm;
MPI_Status status;

main(int argc,char *argv[]) {
  char port_name[MPI_MAX_PORT_NAME];

  printf("HELLO11-MPI\n");
  
  if (MPI_Init(&argc, &argv) != MPI_SUCCESS){       /* initialize MPI */
    printf("MPI_Init error\n");
    exit(1);
  }
  
  MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
  printf("MPI_Init done on %d\n", myrank);

if (argc == 1) { 
  if (myrank == 0) {
    MPI_Open_port(MPI_INFO_NULL, port_name);
    printf("Opened port: %s \n", port_name);  
  }
  MPI_Comm_accept(port_name, MPI_INFO_NULL, 0, 
		MPI_COMM_WORLD, &intercomm);

printf("ACCEPTED\n");
printf("accepted newcomm %d of size %d\n", intercomm, MPI_Comms[intercomm].group->size);  

MPI_Recv(&data, 1, MPI_INT, 0, 0, intercomm, &status);
printf("received %d\n", data);
  if (myrank == 0)
   if (MPI_Close_port(port_name) != MPI_SUCCESS)
	printf("error while closing port\n");
}
else {
  printf("port name %s \n", argv[1]);

  MPI_Comm_connect(argv[1], MPI_INFO_NULL, 0, 
		MPI_COMM_WORLD, &intercomm);
printf("CONNECTED\n");
printf("connected newcomm %d of size %d\n", intercomm, MPI_Comms[intercomm].group->size);  

data = 153;
MPI_Send(&data, 1, MPI_INT, 0, 0, intercomm);

}

  MPI_Finalize();
}
