#include "mpi.h"

#include <stdio.h>

#define WORKTAG		1
#define DIETAG		2

void master(), slave();

int myrank; /* SunOS has problems with this local decl. */

MPI_Comm dup_world;

main(int argc,char *argv[]) {
  printf("HELLO2-MPI\n");
  
  if (MPI_Init(&argc, &argv) != MPI_SUCCESS){		/* initialize MPI */
    printf("MPI_Init error\n");
    exit(1);
  }
  
  MPI_Comm_rank(MPI_COMM_WORLD,	&myrank);
  printf("MPI_Init done on %d\n", myrank);
  
  if (myrank == 0) {
    master();
  } else {
    slave();
  }
  MPI_Finalize();			/* cleanup MPI */
  printf("MPI_Exit done on %d\n", myrank);
  exit(0);
}

void master() {
  MPI_Status	status;
  MPI_Info info;
  MPI_Comm intercomm;
  int proc = 2;
  int errors[proc];
  char *argv[] = { "" };
  int s,d;

  MPI_Comm parent;
  
  printf("Start master  on %d\n", myrank);
  
  MPI_Comm_dup(MPI_COMM_WORLD, &dup_world);
  
  s = 6;
  MPI_Send(&s, 1, MPI_INT, 1, 15, MPI_COMM_WORLD);

  s = 7;
  MPI_Send(&s, 1, MPI_INT, 1, 15, dup_world);
  
  s = 5;
  MPI_Send(&s, 1, MPI_INT, 1, 0, MPI_COMM_WORLD);

}

void slave() {
  MPI_Status	status;
  MPI_Info info;
  MPI_Comm intercomm;
  int proc = 2;
  int errors[proc];
  char *argv[] = { "" };
  int d;
  
  printf("Start slave  on %d\n", myrank);

  MPI_Comm_dup(MPI_COMM_WORLD, &dup_world);

  if (myrank == 1) {
    MPI_Recv(&d, 1, MPI_INT, 0, 0, MPI_COMM_WORLD, &status);
    printf("Received from root %d\n", d);
        
    MPI_Recv(&d, 1, MPI_INT, 0, 15, dup_world, &status);
    printf("Received from root %d\n", d);
    
    MPI_Recv(&d, 1, MPI_INT, 0, 15, MPI_COMM_WORLD, &status);
    printf("Received from root %d\n", d);
   }
}
