#include "mpi.h"
#include "mpiimpl.h"

#include <stdio.h>

#define WORKTAG     1
#define DIETAG      2

void master(), slave();

int myrank; /* SunOS has problems with this local decl. */

MPI_Comm dup_world;
FILE *fp;

main(int argc,char *argv[]) {

  printf("HELLO4-MPI\n");
  if (MPI_Init(&argc, &argv) != MPI_SUCCESS){       /* initialize MPI */
    printf("MPI_Init error\n");
    exit(1);
  }
  
  
  MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
  printf("MPI_Init done on %d\n", myrank);
  
  if (myrank == 0) {
    master();
  } else {
    slave();
  }
  MPI_Finalize();           /* cleanup MPI */
  printf("MPI_Exit done on %d comm %d\n", myrank, MPI_COMM_WORLD);
  exit(0);
}

void master() {
  MPI_Status    status;
  MPI_Info info;
  MPI_Comm intercomm;
  int s,d;

  MPI_Comm parent;
  
  MPI_Comm_get_parent(&parent);
  
  if (parent == MPI_COMM_NULL) {
    printf("I am not spawned!\n");
  }
  else {
    int i;
    printf("I am spawned!\n");
    MPI_Comm_remote_size(parent, &s);
    
    printf("Parent's group size is %d\n", s);
    
    for(i = 0; i <s; i++) {
      printf("Node %d is of rank %d in parent's group\n",
         i, MPI_Comms[parent].group->nodes[i]);
    }
        
    printf("Intercomm number is = %d, snd_context is %d, rcv_context = %d\n", 
    parent, MPI_Comms[parent].snd_context, MPI_Comms[parent].rcv_context);
        
    s = 111;
    MPI_Send(&s, 1, MPI_INT, 0, 66, parent);

    MPI_Recv(&s, 1, MPI_INT, 0, 55, parent, &status);
    printf("Received from parent's root %d\n", s);     
 }
}

void slave() {
}
