#include "mpi.h"
#include <stdio.h>

main(int argc,char *argv[]) {
    int myrank, new_rank;
    int ranks[] = {0};
    MPI_Comm commslave;
    MPI_Group MPI_GROUP_WORLD, grprem;
    
  printf("HELLO5-MPI\n");
  
  if (MPI_Init(&argc, &argv) != MPI_SUCCESS){       /* initialize MPI */
    printf("MPI_Init error\n");
    exit(1);
  }
  
  MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
  printf("MPI_Init done on %d\n", myrank);

  MPI_Comm_group(MPI_COMM_WORLD, &MPI_GROUP_WORLD);
  MPI_Group_excl(MPI_GROUP_WORLD, 1, ranks, &grprem);
  MPI_Comm_create(MPI_COMM_WORLD, grprem, &commslave);

    if (commslave == MPI_COMM_NULL) {
        printf("I do not belong to new Comm %d, world rankr = %d\n",commslave, myrank);
    }
    else {
      printf("I do belong to new Comm %d, world rank = %d\n",commslave, myrank);       
      MPI_Comm_rank(commslave, &new_rank);
      printf("My rank in new comm is %d, and in MPI_COMM_WORLD is %d\n", 
	     new_rank, myrank);       
      MPI_Comm_free(&commslave);
    }
    
  MPI_Group_free(&MPI_GROUP_WORLD);
  MPI_Group_free(&grprem);
    
  MPI_Finalize();
  printf("MPI_Exit done on %d\n", myrank);
  exit(0);
}

