#include "mpi.h"

#include <stdio.h>
#include <stdlib.h>


main(int argc,char *argv[]) {
   int rank, size;
   int data;
    
    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    MPI_Comm_size(MPI_COMM_WORLD, &size);

    if (rank == 0) {
	int i, *buf;
	buf = calloc((size_t)size+1, sizeof(int));

	data = 789;
	MPI_Bcast(&data, 1, MPI_INT, 0, MPI_COMM_WORLD);

	for (i = 0; i < size; i++) buf[i] = 100 + i;

	MPI_Scatter(buf, 1, MPI_INT, &data, 1, MPI_INT, 0, MPI_COMM_WORLD);
	printf("Received from scatter %d\n", data);

        MPI_Barrier(MPI_COMM_WORLD);
	printf("passed barrier %d\n", rank);

	MPI_Gather(&rank, 1, MPI_INT, buf, 1, MPI_INT, 0, MPI_COMM_WORLD);
	for (i = 0; i < size; i++) 
	  printf("%d gathered from %d\n", i, buf[i]);
    }
    else {

	MPI_Bcast(&data, 1, MPI_INT, 0, MPI_COMM_WORLD);
	printf("root broadcasted %d to %d\n", data, rank);

	MPI_Scatter(NULL, 0, MPI_INT, &data, 1, MPI_INT, 0, MPI_COMM_WORLD);
	printf("Received from scatter %d\n", data);

	data = rank + 10;
        MPI_Gather(&data, 1, MPI_INT, NULL, 0, MPI_INT, 0, MPI_COMM_WORLD);

        MPI_Barrier(MPI_COMM_WORLD);
	printf("passed barrier %d\n", rank);

    }

    MPI_Finalize();
    exit(0);
}


